Foreman - Bug #27854

upgrade to 1.21.3 fails with Validation failed: Provisioning templates is invalid

09/15/2019 09:35 AM - Tomer Brisker

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: DB migrations
Target version: 1.21.4
Difficulty: Fixed in Releases: 1.21.4,1.22.2,1.23.1,1.24.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7041,
https://github.com/theforeman/foreman/p
ull/7043
Description

Seeding /usr/share/foreman/db/seeds.d/050-taxonomies.rb
rake aborted!
ActiveRecord: :RecordInvalid: Validation failed:

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

s.rb:80:in ‘raise_validation_error'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

s.rb:52:in “save!'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns.rb:315:in “block in save!'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns.rb:387:in “block in with_transaction_returning_status'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

_adapters/abstract/database_statements.rb:252:in " transaction'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns.rb:212:in "“transaction'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns.rb:385:in "with_transaction_returning_status'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns.rb:315:in "“save!'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

.rb:48:in "“save!'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/collection_association.rb:375:in ‘insert_record'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/has_many_association.rb:36:in "insert_record'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/has_many_through_association.rb:42:in 'insert_record'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord->5.

ns/collection_association.rb:438:in “block (2 levels)

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/collection_association.rb:458:in “replace_on_target'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/collection_association.rb:282:in “add_to_target'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/collection_association.rb:436:in “block in concat_records'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/collection_association.rb:434:in ‘each'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/collection_association.rb:434:in ‘concat_records'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/has_many_association.rb:116:in “concat_records'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.

ns/has_many_through_association.rb:27:in " concat_records'
Provisioning templates is invalid

.1/1lib/active_record/validation
.1/1lib/active_record/validation
.1/1lib/active_record/transactio
.1/1lib/active_record/transactio
.1/1lib/active_record/connection
.1/1lib/active_record/transactio
.1/1lib/active_record/transactio
.1/1lib/active_record/transactio
.1/1lib/active_record/suppressor
.1/1lib/active_record/associatio
.1/1lib/active_record/associatio
.1/1lib/active_record/associatio

.1/1lib/active_record/associatio

in concat_records'

.1/1lib/active_record/associatio

.1/1lib/active_record/associatio

.1/1lib/active_record/associatio

.1/1lib/active_record/associatio

.1/1lib/active_record/associatio

.1/1lib/active_record/associatio

.1/1lib/active_record/associatio
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:119:in “block in concat'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:134:in “block in transaction’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/connection
_adapters/abstract/database_statements.rb:252:in " transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/transactio
ns.rb:212:in “transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:133:in ‘transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:119:in "concat'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/associatio
ns/has_many_through_association.rb:21:in " concat'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:414:in ‘replace_records'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:250:in “block in replace'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:134:in “block in transaction’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/connection
_adapters/abstract/database_statements.rb:254:in “block in transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/connection
_adapters/abstract/transaction.rb:239:in “block in within_new_transaction'
/opt/rh/rh-ruby25/root/usr/share/ruby/monitor.rb:226:in “mon_synchronize'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/connection
_adapters/abstract/transaction.rb:236:in “within_new_transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/connection
_adapters/abstract/database_statements.rb:254:in "“transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/transactio
ns.rb:212:in “transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:133:in ‘transaction'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:250:in "replace'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1ib/active_record/associatio
ns/collection_association.rb:41:in “writer'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/associatio
ns/builder/association.rb:116:in "locations="
/usr/share/foreman/db/seeds.d/050-taxonomies.rb:25:in ‘block (5 levels) in <top (required)>'
/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.7.1/1lib/audited/auditor.rb:336:in “without_
auditing'

/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.7.1/1lib/audited/auditor.rb:105:in “without_
auditing'

/usr/share/foreman/db/seeds.d/050-taxonomies.rb:24:in ‘block (4 levels) in <top (required)>'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/relation/d
elegation.rb:41:in “each'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/relation/d
elegation.rb:41:in “each'

/usr/share/foreman/db/seeds.d/050-taxonomies.rb:23:in "block (3 levels) in <top (required)>'
/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.7.1/1ib/audited/auditor.rb:336:in “without_
auditing'

/usr/share/foreman/db/seeds.d/050-taxonomies.rb:8:in “block (2 levels) in <top (required)>'
/usr/share/foreman/db/seeds.d/050-taxonomies.rb:7:in "“each'
/usr/share/foreman/db/seeds.d/050-taxonomies.rb:7:in ‘block in <top (required)>'
/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:100:in "“as'
/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:106:in "as_anonymous_admin'
/usr/share/foreman/db/seeds.d/050-taxonomies.rb:6:in “~<top (required)>'

Associated revisions

Revision 6e822b4f - 09/16/2019 12:05 PM - Tomer Brisker
Fixes #27854 - Don't fail seed on invalid templates (#7041)
In case any non-default template is invalid, assigning it to the default

taxonomy will fail and block the seeding from continuing. This commit
catches such failures and prints a message informing the user what
to do to fix the issue.

Revision 43c561e8 - 09/17/2019 06:17 AM - Tomer Brisker

Refs #27854 - Only assign valid templates to new taxonomy

If any default template somehow becomes invalid, new taxonomies cannot
be created.

History

#1 - 09/15/2019 09:45 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Tomer Brisker

- Pull request https://github.com/theforeman/foreman/pull/7041 added

#2 - 09/16/2019 12:05 PM - The Foreman Bot
- Fixed in Releases 1.24.0 added

#3 - 09/16/2019 12:10 PM - Tomer Brisker
- Fixed in Releases 1.21.4, 1.22.2, 1.23.1 added

#4 - 09/16/2019 01:01 PM - Tomer Brisker
- Status changed from Ready For Testing to Closed

Applied in changeset 6e822b4f59a9f1b64a15783fdec8f31b5f55abab.

#5 - 09/16/2019 01:21 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/7043 added
